/**********************************************************************
 * $Id: owtform.c,v 1.2 1998/12/09 02:08:07 daniel Exp $
 *
 * Name:     owtform.c
 * Project:  OWT base library
 * Purpose:  Functions to access HTML FORM parameters
 * Author:   Daniel Morissette, danmo@videotron.ca
 *
 **********************************************************************
 * Copyright (c) 1998, Daniel Morissette
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************
 *
 * $Log: owtform.c,v $
 * Revision 1.2  1998/12/09 02:08:07  daniel
 * Converted to use portability library
 *
 * Revision 1.1  1998/12/04 19:15:19  daniel
 * Initial revision
 *
 *
 **********************************************************************/

#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "owt.h"

/*=====================================================================
                    OWT functions to access FORM parameters
 =====================================================================*/

/**********************************************************************
 *                       OWTParseForm()
 *
 * Return a stringlist of "name: value" pairs containing all the 
 * current form input parameters.  The CGI environment variables are
 * checked to establish the CONTENT_LENGTH, and the HTTP_METHOD that
 * was used.
 *
 * Reutrns a StringList that should be freed using CSLDestroy()
 * or NULL if the form parameters could not be read.
 **********************************************************************/
char **OWTParseForm()
{
    char **papszParams;

    return papszParams;
}

/**********************************************************************
 *                       OWTGetFormParam()
 *
 * Look for the form parameter with the specified name, and
 * return a static reference to its value or "" if there is no parameter
 * with this name.  This function is guaranteed to never return a NULL.
 *
 * The caller should not attempt to free the returned string.
 **********************************************************************/
const char *OWTGetFormParam(char **papszParams, const char *pszName)
{
    const char *pszValue = "";

    /* Fetch value in stringlist ... */

    return pszValue;
}

/**********************************************************************
 *                       OWTGetFormParamMulti()
 *
 * Look for the given form parameter with the specified name, and
 * return a StringList with one string for each of its values.  This
 * function should be used for multiple selection lists.
 *
 * The returned StringList will have to be freed using 
 * CSLDestroy().
 **********************************************************************/
char **OWTGetFormParamMulti(char **papszParams, const char *pszName)
{
    char **papszValues = NULL;

    /* Fetch value in stringlist ... */

    return papszValues;
}

