/**********************************************************************
 * $Id: owthtcomblock.h,v 1.1.1.1 1999/06/04 19:37:36 daniel Exp $
 *
 * Name:     owthtcomblock.h
 * Project:  OWT HTML manipulation library - COM Interface
 * Purpose:  Header file for the OWTHtComBlock wrapper class
 * Author:   Daniel Morissette, danmo@videotron.ca
 *
 **********************************************************************
 * Copyright (c) 1999, Daniel Morissette
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************
 *
 * $Log: owthtcomblock.h,v $
 * Revision 1.1.1.1  1999/06/04 19:37:36  daniel
 * First kind of complete version
 *
 **********************************************************************/

#ifndef _OWTHTCOMBLOCK_H_INCLUDED_
#define _OWTHTCOMBLOCK_H_INCLUDED_

#include <objbase.h>
#include "owtht.h"

/*---------------------------------------------------------------------
 *                        (class) OWTHtComBlock
 *
 * Wrapper class for COM components derived from the OWTHt* classes
 * to allow passing components as children of other OWTHtBlock objects.
 *
 * See owthtcomblock.cpp for a more complete description.
 *--------------------------------------------------------------------*/
class OWTHtComBlock: public OWTHtBlock
{
protected:
    IDispatch   *m_pIBlock;

    DISPID      m_dispidGetName;
    DISPID      m_dispidSetName;
    DISPID      m_dispidSetText;
    DISPID      m_dispidDraw;

public:
    OWTHtComBlock(IUnknown *pBlock);

    virtual ~OWTHtComBlock();

    virtual void    SetText(char **papszSrc, GBool bMakeCopy=TRUE);
    virtual void    SetText(char *pszNewText);
    virtual void    Draw(FILE *fp = NULL);
    virtual const char *GetName();
    virtual void    SetName(const char *pszNewName);

#ifdef _not_applicable_
    void    SetChildText(const char *pszChildName, 
                         char **papszSrc, GBool bMakeCopy=TRUE);
    void    SetChildText(const char *pszChildName,
                         const char *pszText);

    OWTHtBlock *GetChild(const char *pszChildName);
    OWTHtBlock *SetChild(const char *pszChildName,
                                 OWTHtBlock *poNewChild);
    void        ExpandEnvVars(OWTCGIEnv *poCGIEnv =NULL,
                              char **papszValues = NULL);
#endif

};

#endif /* _OWTHTCOMBLOCK_H_INCLUDED_ */
